import { HTTP_REQUEST_URL, HEADER, TOKENNAME, } from '@/config/app';
// import { checkLogin } from '../libs/login';
import store from '../store';
import props from '../uni_modules/uview-ui/libs/config/props';


function toLogin() {
  store.commit("LOGOUT");
  uni.showToast({
    title: '请登录',
    icon: 'none',
    duration: 1000
  });
}

/**
 * 发送请求
 */
function baseRequest(url, method, data, {
  noAuth = false,
  noVerify = false
}) {
  console.log('当前环境', process.env.NODE_ENV);
  let Url = HTTP_REQUEST_URL,
    header = HEADER;

  if (!noAuth) {
    //登录过期自动登录
    // if (!store.state.app.token && !checkLogin()) {
    if (!store.state.app.token) {
      toLogin();
      return Promise.reject({
        msg: '未登录'
      });
    }
  }

  if (store.state.app.token) header[TOKENNAME] = 'Bearer ' + store.state.app.token;

  return new Promise((reslove, reject) => {
    uni.request({
      url: Url + '/api/' + url,
      method: method || 'GET',
      header: header,
      data: data || {},
      success: (res) => {
        // #ifdef APP-PLUS
        console.log('app', Url + '/api/' + url, res.data);
        // #endif
        if (noVerify)
          reslove(res.data, res);
        else if (res.data.status == 200)
          reslove(res.data, res);
        else if ([410000, 410001, 410002, 40000].indexOf(res.data.status) !== -1) {
          toLogin();
          reject(res.data);
        } else if (res.data.status == 501) {
          uni.reLaunch({
            url: '/pages/error/index'
          })
          reject(res.data);
        } else
          reject(res.data.message || '系统错误');
      },
      fail: (message) => {
        reject('请求失败');
      }
    })
  });
}

const request = {};
['options', 'get', 'post', 'put', 'head', 'delete', 'trace', 'connect'].forEach((method) => {
  request[method] = (api, data, opt) => baseRequest(api, method, data, opt || {})
});

export default request;
